#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <stdio.h>

// Hier die verwendete Taktfrequenz in Hz eintragen, wichtig!
#define F_CPU 1000000

#include <util/delay.h>
#include "lcd_162.h"

/* NOP */
#define NOP() asm("nop");


//================================
// Initialisierung
//================================
void system_init(void)
{
	unsigned char i;

	//----------------------------
	//Ports kofigurieren

	//DDRn Logisch 0 = Eingang
	//DDRn Logisch 1 = Ausgang

	//PORTn Logisch 0 = Pull-up Widerstand deaktiviert
	//PORTn Logisch 1 = Pull-up Widerstand aktiviert

	//Port B: Pin 0 = 
	//        Pin 1 = 
	//        Pin 2 = 
	//        Pin 3 = 
	//        Pin 4 = 
	//        Pin 5 = 
	//        Pin 6 =  
	//        Pin 7 =  
	DDRB = DDRB;
	PORTB = PORTB;

	//Port C: Pin 0 = Display Data 4
	//        Pin 1 = Display Data 5
	//        Pin 2 = Display Data 6
	//        Pin 3 = Display Data 7
	//        Pin 4 = Display E
	//        Pin 5 = Display RS
	//        Pin 6 = 
	//        Pin 7 = 
	DDRC = 0x3F;
	PORTC = PORTC;

	//Port D: Pin 0 = 
	//        Pin 1 = 
	//        Pin 2 = 
	//        Pin 3 = 
	//        Pin 4 = 
	//        Pin 5 = 
	//        Pin 6 = 
	//        Pin 7 = 
	DDRD = DDRD;
	PORTD = PORTD;


	//----------------------------
	// LCD initialisieren

	lcd_init();


	//----------------------------
	//Kleine Animation (90 Byte)
	
	lcd_set_cursor(0,1);
	//          1234567890123456
	lcd_string("Boot");
	lcd_set_cursor(0,2);
	for (i=0; i<16; i++) { _delay_ms(50); lcd_string("\xA5"); }
	i=10; do {_delay_ms(30);} while(--i);
	lcd_clear();
	
}



//================================
// Hauptprogramm
//================================
int main(void)
{
	//System initialisieren
	system_init();

	//Display beschriften
	lcd_set_cursor(0,1);
			  //0123456789012345
	lcd_string("Test            ");
	
	do
	{

	}
	while(1);
}
